clear
close all

% image de la grenouille
frog=imread('/Users/marcel/Documents/MATLAB/0-images-exemples/house.jpg');
I=rgb2gray(frog);
I=double(I)/255.;

% filtre de Prewitt
Ph=fspecial('prewitt');
Pv=-Ph';
IPh=filter2(Ph,I);
IPv=filter2(Pv,I);
IPvh=sqrt(IPv.^2+IPh.^2);

figure(1)
colormap('gray')
subplot(3,3,1), imagesc(IPv), colorbar, title('Prewitt vertical')
axis('square')
subplot(3,3,2), imagesc(IPh), colorbar, title('Prewitt horizontal')
axis('square')
subplot(3,3,3), imagesc(IPvh),colorbar, title('Prewitt complet')
axis('square')

% filtre de Sobel
Sh=fspecial('sobel');
Sv=-Sh';
ISh=filter2(Sh,I);
ISv=filter2(Sv,I);
ISvh=sqrt(ISv.^2+ISh.^2);

subplot(3,3,4), imagesc(ISv), colorbar, title('Sobel vertical')
axis('square')
subplot(3,3,5), imagesc(ISh), colorbar, title('Sobel horizontal')
axis('square')
subplot(3,3,6), imagesc(ISvh),colorbar, title('Sobel complet')
axis('square')

% filtres de Roberts
Ra=[1 0;0 -1];
Rb=rot90(Ra, -1);
IRa=filter2(Ra,I);
IRb=filter2(Rb,I);
IRab=sqrt(IRa.^2+IRb.^2);

subplot(3,3,7), imagesc(IRa), colorbar, title('Roberts diagonal')
axis('square')
subplot(3,3,8), imagesc(IRb), colorbar, title('Roberts anti-diagonall')
axis('square')
subplot(3,3,9), imagesc(IRab),colorbar, title('Roberts complet')
axis('square')

% seuillages/comparaison
seuil=0.8;
IPs=(IPvh>seuil);

ISs=(ISvh>seuil);
seuil2=1.05;
ISs2=(ISvh>seuil2);

IRs=(IRab>seuil);
seuil2=0.27;
IRs2=(IRab>seuil2);

figure(2)
colormap('gray')
subplot(2,3,1), imagesc(IPs), colorbar, title('Prewitt avec seuil=0.8')
axis('square')
subplot(2,3,2), imagesc(ISs), colorbar, title('Sobel avec mme seuil')
axis('square')
subplot(2,3,3), imagesc(IRs), colorbar, title('Roberts avec mme seuil')
axis('square')
subplot(2,3,5), imagesc(ISs2), colorbar, title('Sobel avec seuil=1.05')
axis('square')
subplot(2,3,6), imagesc(IRs2), colorbar, title('Roberts avec seuil=0.27')
axis('square')